<?php

/**
 * Includes Carrier Service Request class
 */
if (!defined('ABSPATH')) {
    exit;
}

if (!class_exists("EnWooAddonsCarrierService")) {

    class EnWooAddonsCarrierService extends EnWooAddonsQuoteSettings {

        public $always_auto_residential_accessorial;
        public $always_lift_gate_quote_accessorial;
        public $post_data;
        public $cart;
        public $cart_arry;
        public $request_key;
        public $microtime_carrier;
        public $EnWooAddonsQuoteSettings;
        public $plugin_id;

        public function __construct() {

            parent::__construct();
            add_filter('en_woo_addons_carrier_service_quotes_request', array($this, 'carrier_service_quotes_request'), 10, 2);
        }

        /**
         * set index autoResidentials for carrier request
         * @return array type
         */
        public function auto_residential_enable() {

            $this->post_data['autoResidentials'] = '1';
        }

        /**
         * set index liftGateWithAutoResidentials for carrier request
         * @return array type
         */
        public function auto_resid_wd_lift_enable() {

            $this->post_data['liftGateWithAutoResidentials'] = '1';
        }

        /**
         * carrier request receive from standard plugin with plugin id
         * @param array type $post_data
         * @param string type $plugin_id
         * @return array type
         */
        public function carrier_service_quotes_request($post_data, $plugin_id) {

            $this->post_data = $post_data;
            $this->plugin_id = $plugin_id;

            if (isset($this->plugins_dependencies[$plugin_id]) && $this->get_validate_street_address()) {

                $this->post_data = $this->update_carrier_service();
            }
            return $this->post_data;
        }

        /**
         * generete request_key for carrier request
         * @return string type
         */
        public function request_key() {

            session_start();
            return $_SESSION['session_request_key'];
        }

        /**
         * update carrier service for every carrier request 
         * @return array type
         */
        public function update_carrier_common() {

            $this->post_data['requestKey'] = $this->session_request_key;
            $this->post_data['server_name'] = $_SERVER['SERVER_NAME'];
            $this->post_data['addressLine'] = (isset($_POST['s_address'])) ? $this->trim_string($_POST['s_address']) : $this->shipping_address;
            $this->post_data['addressLine2'] = (isset($_POST['s_address_2'])) ? $this->trim_string($_POST['s_address_2']) : $this->shipping_address_2;

            $en_default_unconfirmed_address_types_to = get_option('en_default_unconfirmed_address_types_to');
            $this->post_data['defaultRADAddressType'] = ($en_default_unconfirmed_address_types_to && strlen($en_default_unconfirmed_address_types_to) > 0) ? $en_default_unconfirmed_address_types_to : 'residential';

            if (!isset($this->post_data['receiverCountryCode'])) {
                $this->post_data['receiverCountryCode'] = (isset($_POST['s_country'])) ? $this->trim_string($_POST['s_country']) : $this->shipping_country;
            }

            if ($this->plugin_id == "fedex_small") {
                $this->post_data['receiverStreetLines'] = (isset($_POST['s_address'])) ? array($this->trim_string($_POST['s_address'])) : array($this->shipping_address);
            }
        }

        /**
         * update carrier service for autoResidentials & liftGateWithAutoResidentials
         * @return array type
         */
        public function update_carrier_service() {

            if ($this->rtrn_valid_option_val("option_1", $this->plugin_id) &&
                    $this->rtrn_valid_fr_addon('addon_1', $this->plugin_id) &&
                    $this->get_validate_street_address()) {
                $this->auto_residential_enable();
                $this->rtrn_valid_option_val("option_2", $this->plugin_id) && $this->rtrn_valid_fr_addon('addon_2', $this->plugin_id) ?
                                $this->auto_resid_wd_lift_enable() : "";
            }

            $this->update_carrier_common();
            return $this->post_data;
        }

    }

    new EnWooAddonsCarrierService();
}