<?php

/**
 * Includes Carrier Service Request class
 */
if (!defined('ABSPATH')) {
    exit;
}

if (!class_exists("EnWooAddonsTabSettings")) {

    class EnWooAddonsTabSettings extends WC_Settings_Page {

        public function __construct() {

            $this->id = 'en-woo-addons';
            add_filter('woocommerce_settings_tabs_array', array($this, 'add_settings_tab'), 50);
            add_action('woocommerce_sections_' . $this->id, array($this, 'output_sections'));
            add_action('woocommerce_settings_' . $this->id, array($this, 'output'));
            add_action('woocommerce_settings_save_' . $this->id, array($this, 'save'));
        }

        /**
         * Eniture woo addons Setting Tab For Woocommerce
         * @param array $settings_tabs
         * @return type
         */
        public function add_settings_tab($settings_tabs) {

            $settings_tabs[$this->id] = __('Residential Address Detection', 'woocommerce-settings-en-woo-addons');
            return $settings_tabs;
        }

        /**
         * Eniture woo addons Setting Sections
         * @return type
         */
        public function get_sections() {

            $sections = array(
                '' => __('Settings', 'woocommerce-settings-en-woo-addons'),
                'section-1' => __('Settings', 'woocommerce-settings-fedex_freight'),
            );
            return apply_filters('woocommerce_get_sections_' . $this->id, $sections);
        }

        /**
         * WC get settings
         * @param type $section
         * @return type
         */
        public function get_settings($section = null) {

            switch ($section) {

                case 'section-0' :
                    $settings = array();
                    break;

                case 'section-1':
                    $settings = array();
                    break;

                default:
                    $settings = array();
                    break;
            }

            $settings = apply_filters('en_woo_addons_settings', $settings, $section, en_plugin_id_fr_addon);
            return apply_filters('woocommerce-settings-fedex_freight', $settings, $section);
        }

        /**
         * Eniture woo addons Settings Output
         * @global $current_section $current_section
         */
        public function output() {

            global $current_section;
            $settings = $this->get_settings($current_section);
            WC_Admin_Settings::output_fields($settings);
        }

        /**
         * Eniture woo addons Save Settings
         * @global $current_section $current_section
         */
        public function save() {

            global $current_section;
            $settings = $this->get_settings($current_section);
            WC_Admin_Settings::save_fields($settings);
        }

    }

    new EnWooAddonsTabSettings();
}