<?php

/*
  Plugin Name: Residential Address Detection
  Plugin URI:  https://eniture.com/products/
  Description: Detects residential addresses so that the carrier’s residential delivery fee is included in shipping rate estimates. For exclusive use with Eniture Technology’s Small Package Quotes and LTL Freight Quotes plugins.
  Version:     1.0.0
  Author:      Eniture Technology
  Author URI:  https://eniture.com
  License:     GPL2
  License URI: https://www.gnu.org/licenses/gpl-2.0.html
  Text Domain: eniture-technology
 */


if (!defined('ABSPATH')) {

    exit; /* Not allowed to access directly */
}

if (!function_exists('is_plugin_active')) {

    require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
}

/**
 * Check woocommerce installlation
 */
function eo_woo_addons_avaibility_error() {

    $class = "error";
    $message = "It requires WooCommerce in order to work , Please <a target='_blank' href='https://wordpress.org/plugins/woocommerce/installation/'>Install</a> WooCommerce Plugin.";
    echo"<div class=\"$class\"> <p>$message</p></div>";
}

if (!is_plugin_active('woocommerce/woocommerce.php')) {

    add_action('admin_notices', 'eo_woo_addons_avaibility_error');
}
register_deactivation_hook(__FILE__, "residential_address_detection_uninstall");

/**
 * Define constants
 */
define('addon_plugin_url', __DIR__);
include_once( __DIR__ . '/includes/en-woo-addons-genrt-request-key.php' );
include_once( __DIR__ . '/includes/en-woo-plugin-details.php' );
include_once( __DIR__ . '/includes/en-woo-addons-includes.php' );
include_once( __DIR__ . '/includes/en-woo-addons-addresses.php' );
include_once( __DIR__ . '/includes/en-woo-addons-quote-settings.php' );
include_once( __DIR__ . '/includes/en-woo-addons-curl-request.php' );
include_once( __DIR__ . '/includes/en-woo-addons-carrier-service.php' );
include_once( __DIR__ . '/includes/en-woo-addons-web-quotes.php' );

/**
 * Deactivavte the plugin  
 */
function residential_address_detection_uninstall() {

    include_once( __DIR__ . '/uninstall.php' );
}

add_action('admin_bar_menu', 'en_web_hook_to_update_residential_status');

/**
 * Will run after Webhook by our eniture to check the
 */
function en_web_hook_to_update_residential_status()
{
    $action = isset($_POST['action']) ? sanitize_text_field($_POST['action']) : '';
    
    if ($action == '') {
        $residential_message = get_option('en_residential_message');
        $residential_message_status = get_option('en_residential_message_status');
        if(is_admin()){
        /* if there is any message */
        if (!empty($residential_message) && $residential_message != '') {
            $fullstop = (substr($residential_message, -1) == '.') ? '' : '.';
            /* Error case */
            if ($residential_message_status == 'ERROR') {
                /* update these notifications after checking flags */
                echo '<div id="message" class="notice-dismiss-residential notice-error notice is-dismissible "><p><strong>Residential Address Detection : </strong>' . $residential_message . $fullstop . ' Renewal attempt because of current subscription expired OR hits consumed.</p><span id="residential-del">Delete</span></div>';
            }
            /* Success case */
            if ($residential_message_status == 'SUCCESS') {
//                echo '<div id="message" class="notice-dismiss-residential notice-success notice is-dismissible "><p><strong>Residential Address Detection : </strong>' . $residential_message . $fullstop . ' Renewal attempt because of current subscription expired OR hits consumed.</p><span id="residential-del">Delete</span></div>';
                echo '<div id="message" class="notice-dismiss-residential notice-success notice is-dismissible "><p><strong>Residential Address Detection : </strong>' . ' The subscription for this plugin was renewed because the previous plan expired or was depleted.</p><span id="residential-del">Delete</span></div>';
            }
        }
      }
    }
}


add_action('wp_ajax_nopriv_en_woo_addons_hide_residential_message',
    'en_woo_addons_hide_residential_message_func');
add_action('wp_ajax_en_woo_addons_hide_residential_message',
    'en_woo_addons_hide_residential_message_func');
/**
 * Ajax request to delete the bin notification.
 */
function en_woo_addons_hide_residential_message_func()
{
    delete_option('en_residential_message');
    delete_option('en_residential_message_status');
    echo 'true';
    exit;
}
